import java.util.ArrayList;

public class StudentService {
    private String className;
    private ArrayList<Student> studentList;

    public StudentService(String className) {
        this.className = className;
        this.studentList = new ArrayList<>();
    }

    public String getClassName() {
        return className;
    }

    public void setClassName(String className) {
        this.className = className;
    }

    public void addStudent(Student student){
        studentList.add(student);
    }

    public ArrayList<String> fetchStudentNames(){
        ArrayList<String> namesList = new ArrayList<>();
        for (Student student : studentList){
            namesList.add(student.getSurname());
        }
        return namesList;
    }

    public int fetchStudentsAmount(){
        return studentList.size();
    }

    public void showStudentNames(){
        for(int i = 0; i < studentList.size(); i++){
            System.out.println((i+1) + " " + studentList.get(i).getName() + " " + studentList.get(i).getSurname());
        }
    }

    public void showStudentsWithSurname(String surname){
        System.out.println("Students with " + surname + " as surname:");
        for(Student student : studentList){
            if (student.getSurname().equals(surname)){
                System.out.println(student.getSurname() + " " + student.getName());
            }
        }
    }

    public ArrayList<Student> fetchStudentsWithGradeHigherThan(double grade) {
        ArrayList<Student> studentsWithHigherGradeList = new ArrayList<>();
        for(Student student : studentList){
            if(student.calculateFinalGrade() > grade){
                studentsWithHigherGradeList.add(student);
            }
        }
        return studentsWithHigherGradeList;
    }

}