import java.util.ArrayList;

public class TrainCarriage {
    private int maxSeats;
    private ArrayList<Passenger> passengerList;

    public TrainCarriage(int maxSeats) {
        this.maxSeats = maxSeats > 0 ? maxSeats : 50;
        passengerList = new ArrayList<>();
    }
    public int getMaxSeats() {
        return maxSeats;
    }
    public ArrayList<Passenger> getPassengerList() {
        return passengerList;
    }

    public boolean addPassenger(Passenger passenger){
        if(passengerList.size() < maxSeats){
            this.passengerList.add(passenger);
            System.out.println("New passenger added");
            return true;
        }
        System.out.println("Train carriage already full");
        return false;
    }

    public void displayPassengers(){
        for(Passenger passenger : this.passengerList){
            passenger.display();
        }
    }

    public void displayPassengersHavingIndex(){
        for(int i = 0; i < passengerList.size(); i++){
            passengerList.get(i).display();
        }
    }

    public void displayPassengersNameSurname(){
        for(Passenger passenger : this.passengerList){
            System.out.println(passenger.getName() + " " + passenger.getSurname());
        }
    }

    public void displayCarriageInfo(){
        System.out.println("Total number of seats: " + maxSeats);
        System.out.println("The number of seats that are taken: " + passengerList.size());
        System.out.println("The number of seats that are available: " + (maxSeats - passengerList.size()));
        System.out.println("Passengers details:");
        displayPassengers();
    }

    public int countEntitledToSeniorDiscount() {
        int counter = 0;
        for(Passenger passenger : this.passengerList){
            if(passenger.getAge() >= 65){
                counter++;
            }
        }
        return counter;
    }

    public int countEntitledToSeniorDiscountVs2() {
        int counter = 0;
        for(int i = 0; i < passengerList.size(); i++){
            if(passengerList.get(i).getAge() >= 65){
                counter++;
            }
        }
        return counter;
    }

}
